import { world, EquipmentSlot } from "@minecraft/server";

world.afterEvents.entityHitEntity.subscribe(event => { 
    const { damagingEntity, hitEntity } = event;
    if (damagingEntity && damagingEntity.typeId === "minecraft:player") {
        const equipment = damagingEntity.getComponent("minecraft:equippable");
        const mainHandItem = equipment.getEquipment(EquipmentSlot.Mainhand);
        const offHandItem = equipment.getEquipment(EquipmentSlot.Offhand);

        if (mainHandItem && mainHandItem.typeId.startsWith("tunekeshi:b")) {
            let damageAmount = 1;
            switch (mainHandItem.typeId) {
                case "tunekeshi:b1":
                    damageAmount = 5;
                    break;
                case "tunekeshi:b2":
                    damageAmount = 7;
                    break;
                case "tunekeshi:b3":
                    damageAmount = 8;
                    break;
                case "tunekeshi:b4":
                    damageAmount = 10;
                    break;
                case "tunekeshi:b5":
                    damageAmount = 7;
                    break;
                case "tunekeshi:b6":
                    damageAmount = 12;
                    break;
                case "tunekeshi:b7":
                    damageAmount = 12;
                    break;
                case "tunekeshi:b8":
                    damageAmount = 8;
                    break;
                case "tunekeshi:b9":
                    damageAmount = 12;
                    break;
                case "tunekeshi:b10":
                    damageAmount = 12;
                    break;
                case "tunekeshi:b11":
                    damageAmount = 10;
                    break;
                case "tunekeshi:b12":
                    damageAmount = 9;
                    break;
                case "tunekeshi:b13":
                    damageAmount = 7;
                    break;
                case "tunekeshi:b14":
                    damageAmount = 7;
                    break;
                case "tunekeshi:b15":
                    damageAmount = 2;
                    break;
                case "tunekeshi:b16":
                    damageAmount = 12;
                    break;
                case "tunekeshi:b17":
                    damageAmount = 10;
                    break;
                case "tunekeshi:b18":
                    damageAmount = 9;
                    break;
                case "tunekeshi:b19":
                    damageAmount = 10;
                    break;
                case "tunekeshi:b20":
                    damageAmount = 12;
                    break;
                case "tunekeshi:b21":
                    damageAmount = 11;
                    break;
                case "tunekeshi:b22":
                    damageAmount = 13;
                    break;
                case "tunekeshi:b23":
                    damageAmount = 6;
                    break;
                case "tunekeshi:b24":
                    damageAmount = 7;
                    break;
                case "tunekeshi:b25":
                    damageAmount = 11;
                    break;
                case "tunekeshi:b26":
                    damageAmount = 11;
                    break;
            }

            hitEntity.runCommandAsync(`damage @e[type=!item,type=!player,r=2] ${damageAmount}`);
            hitEntity.clearVelocity();
            hitEntity.runCommandAsync('particle minecraft:critical_hit_emitter ~~~');

            damagingEntity.runCommandAsync('playsound game.player.attack.sweep @a ~ ~ ~ 0.8 1 0');
            damagingEntity.runCommandAsync('scoreboard players set @s no 0');
            damagingEntity.runCommandAsync('scoreboard players add @s level1 1');

            if (offHandItem && offHandItem.hasTag("a:test")) {
                damagingEntity.runCommandAsync('scoreboard objectives add double dummy double');
                damagingEntity.runCommandAsync('scoreboard players add @s double 1');
                damagingEntity.runCommandAsync('scoreboard players set @s no_off 0');
                damagingEntity.runCommandAsync('scoreboard players add @s level1 1');
            }

            if (mainHandItem.typeId === "tunekeshi:b6") {
                hitEntity.runCommandAsync('effect @s slowness 5 2 true');
                hitEntity.runCommandAsync('effect @s weakness 10 2 true');
            }

            if (mainHandItem.typeId === "tunekeshi:b7" || mainHandItem.typeId === "tunekeshi:b9" || mainHandItem.typeId === "tunekeshi:b11") {
                hitEntity.runCommandAsync('effect @s wither 8 5 true');
            }

            if (mainHandItem.typeId === "tunekeshi:b10") {
                hitEntity.runCommandAsync('summon lightning_bolt');
            }
        }
    }
});